#ifndef _ASSEMBLER_HPP_
#define _ASSEMBLER_HPP_

#include "sparseMatrix.hpp"
#include "grid.hpp"

class HeatProblem;

class HeatAssembler {

  public :

    HeatAssembler(){};
    HeatAssembler(Grid* g, HeatProblem*);

    // Fills the matrix with heat equation discretization coefficients
    void assembleMatrix(double dt);
    // Adds source term in RHS
    void assembleRHS(rvec& un,double t, double dt);

    SparseMatrix& getMatrix() {return _A;};
    rvec& getRHS() {return _rhs;};

  private:

    SparseMatrix _A;
    rvec         _rhs;

    HeatProblem* _pb; // Source term function
    Grid*        _grid;

};

#endif // _ASSEMBLER_HPP_
