#ifndef _GRID_HPP_
#define _GRID_HPP_

#include "parameters.hpp"

// A cartesian grid. The size of the domain is fixed: it is [0,1]x[0,1]
class Grid {

  public:

    Grid() {};
    // Constructor with configuration (reads number of points in each direction)
    Grid(Parameters& p);
    
    // Returns the spacing discretization step in direction dim (0:x, 1:y)
    double getSpacing(uint dim);

    // Returns the number of points in given dimension
    uint getNbPoints(uint dim);

    // Gives the matrix row ID given position in grid
    uint index1D(uint i, uint j);

    // Gives the position in grid from matrix row index
    void index2D(uint row,uint& i, uint& j);

    // Set coordinates
    void coords(uint i, uint j, double&x, double& y);

  private:
    std::array<uint  ,2> _N;
    std::array<double,2> _h;

};




#endif//_GRID_HPP_
