#ifndef _LINEAR_SOLVER_HPP_
#define _LINEAR_SOLVER_HPP_

#include "parameters.hpp"
#include "grid.hpp"
#include "sparseMatrix.hpp"

enum struct solverType {
  DIRECT=0,CG=1
};

// A solver for a matrix vector pb Ax=b
//
//
class LinearSolver {

  public :


    LinearSolver() {};
    // Reads the entry "linear solver" in parameters to create a solver
    LinearSolver(Parameters* p, Grid* g);

    // Solves Ax=b. Algorithm is selected with _type
    void solve(SparseMatrix& A, rvec& x, rvec& b);

  private : 

    // Conjugate gradient
    void solveCG(SparseMatrix& A, rvec& x, rvec& b);

    solverType _type;

    // Links to other structures
    Parameters* _params;
    Grid*       _grid;

};




#endif//_LINEAR_SOLVER_HPP_
